
library ieee;
use ieee.std_logic_1164.all;
-- pragma translate_off
--library UNISIM;
--use UNISIM.VCOMPONENTS.ALL;
-- pragma translate_on

entity Barrel is
   port (a : in std_logic_vector (6 downto 0);
         cin : in std_logic_vector (3 downto 0);
         cout : out std_logic_vector (3 downto 0);
         b : out std_logic_vector (3 downto 0);
         sel : in std_logic_vector (2 downto 0));
end entity Barrel;


architecture RTL of Barrel is

   signal lsb : std_logic_vector (3 downto 0);
   signal sel1 : std_logic_vector (1 downto 0);
   signal sel2 : std_logic;

begin
   -- split sel into LSB and MSB
   sel1 <= sel (1 downto 0);
   sel2 <= sel (2);
   -- shift 0, 1, 2, or 4
   LSBShifter: process (a, sel1)
   begin
      case sel1 is
         when B"00" =>
            lsb <= a(3 downto 0);
         when B"01" =>
            lsb <= (3 => a(4), 2 => a(3), 1 => a(2), 0 => a(1));
         when B"10" =>
            lsb <= (3 => a(5), 2 => a(4), 1 => a(3), 0 => a(2));
         when B"11" =>
            lsb <= (3 => a(6), 2 => a(5), 1 => a(4), 0 => a(3));
         when others =>
            lsb <= a(3 downto 0);
      end case;
   end process LSBShifter;
   cout <= lsb;
   -- shift by 4
   MSBShifter: process (lsb, cin, sel2)
   begin
      case sel2 is
         when '0' =>
            b <= lsb;
         when '1' =>
            b <= cin;
         when others =>
            b <= lsb;
      end case;
   end process MSBShifter;
end architecture RTL;

